﻿Imports System.IO
Imports SevenZip

Module Sbi
    Dim patchname As String

    Public Sub Sbi_Scan()
        If My.Computer.Network.IsAvailable = False Then MsgBox("Connections is not Available", vbOKOnly + vbExclamation) : Exit Sub

        If File.Exists(Replace(percorso, Path.GetExtension(percorso), "") & ".sbi") Then Exit Sub

        If File.Exists(MedExtra & "Plugins\db\Sbi_List.txt") = False And My.Computer.Network.IsAvailable = True Then
            My.Computer.Network.DownloadFile("http://speedvicio.esy.es/MedGuiR/Patch/Psx/Sbi/Sbi_List.txt", MedExtra & "Plugins\db\Sbi_List.txt", "Speedvicio", "AriA", True, 500, True)
        ElseIf File.Exists(MedExtra & "Plugins\db\Sbi_List.txt") = False And My.Computer.Network.IsAvailable = False Then
            Exit Sub
        End If

        Dim oRead As StreamReader

        Try
            'n_psx = Path.GetFileName(percorso)
            'p_psx = percorso
            'Read_PSX()
            oRead = File.OpenText(MedExtra & "Plugins\db\Sbi_List.txt")
            While oRead.Peek <> -1
                'If percorso.Contains(oRead.ReadLine()) Then
                'Or percorso.Contains(oRead.ReadLine())
                If Serial_PSX.Contains(oRead.ReadLine()) Then
                    patchname = oRead.ReadLine

                    Dim mx As String = MsgBox("Your PSX game needs a LaserLock patch to work properly" & vbCrLf &
                                            "Do you want to download and/or apply it?", vbYesNo + vbInformation)

                    If mx = vbYes Then get_SbiPatch() Else Exit Sub

                End If

            End While

            oRead.Dispose()
            oRead.Close()
        Catch ex As Exception
            MGRWriteLog("Sbi - Sbi_Scan:" & ex.Message)
        Finally
            oRead.Dispose()
            oRead.Close()
        End Try

    End Sub

    Public Sub get_SbiPatch()
        Try
            If Directory.Exists(MedExtra & "Patch\Psx\Sbi") Then
            Else
                Directory.CreateDirectory(MedExtra & "Patch\Psx\Sbi")
            End If

            If File.Exists(MedExtra & "Patch\Psx\Sbi\" & patchname & ".7z") Then GoTo PatchSkip

            My.Computer.Network.DownloadFile("http://speedvicio.esy.es/MedGuiR/Patch/Psx/Sbi/" & "[" & patchname & "].7z", MedExtra & "Patch\Psx\Sbi\" & patchname & ".7z", "Speedvicio", "AriA", True, 500, True)

            Dim infoReader As System.IO.FileInfo
            infoReader = My.Computer.FileSystem.GetFileInfo(MedExtra & "Patch\Psx\Sbi\" & patchname & ".7z")

            If Dir(MedExtra & "Patch\Psx\Sbi\" & patchname & ".7z") = "" Or infoReader.Length < 100 Then
                MsgBox("No " & patchname & " patch found, please try later.", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Download error")
                System.IO.File.Delete(MedExtra & "Patch\Psx\Sbi\" & patchname & ".7z")
                Exit Sub
            End If

PatchSkip:

            'Call contr_os()
            SevenZipExtractor.SetLibraryPath(MedExtra & "Plugins\" & sevenzdll)
            Dim szip As SevenZipExtractor = New SevenZipExtractor(MedExtra & "Patch\Psx\Sbi\" & patchname & ".7z")
            szip.ExtractArchive(MedExtra & "Patch\Psx\Sbi\")
            szip.Dispose()

            For Each foundFile As String In My.Computer.FileSystem.GetFiles(
                MedExtra & "Patch\Psx\Sbi\", FileIO.SearchOption.SearchTopLevelOnly, "*.sbi")
                My.Computer.FileSystem.MoveFile(foundFile, Replace(percorso, Path.GetExtension(percorso), "") & ".sbi", True)
                Exit For
            Next

            MsgBox("All done, patch applied!", vbOKOnly + vbInformation)

        Catch exio As IOException
            MGRWriteLog("Sbi - get_SbiPatch:" & exio.Message)
        Catch ex As Exception
            MGRWriteLog("Sbi - get_SbiPatch:" & ex.Message)
        End Try

    End Sub
End Module