﻿Imports System.IO

Module xSetting
    Dim row, p_c As String
    Public xValue, firmwarepath As String

    Public Sub ReadXValue()
        Try
            Using reader As New StreamReader(MedGuiR.TextBox4.Text & "\mednafen-09x.cfg")
                While Not reader.EndOfStream
                    row = reader.ReadLine
                    SetValue()
                    SetGeneral()
                    'Exit While
                End While
                reader.Dispose()
                reader.Close()
            End Using
            update_setting()
        Catch e As Exception
            Console.WriteLine("The file could not be read:")
            Console.WriteLine(e.Message)
        End Try
    End Sub
    Public Sub ReadPSValue()

        Dim addpath As String
        If IO.File.Exists(MedGuiR.TextBox4.Text & "\" & "pgconfig\" & System.IO.Path.GetFileNameWithoutExtension(MedGuiR.TextBox1.Text) & "." & p_c & ".cfg") = True Then
            addpath = "pgconfig\" & System.IO.Path.GetFileNameWithoutExtension(MedGuiR.TextBox1.Text) & "."
            Setting.CheckBox6.Checked = False
            Setting.CheckBox59.Checked = True
        ElseIf IO.File.Exists(MedGuiR.TextBox4.Text & "\" & p_c & ".cfg") = True Then
            Read_Desync()
            If contdes = 1 Then
                File.Delete(MedGuiR.TextBox4.Text & "\" & consoles & ".cfg”)
            Else
                addpath = ""
                Setting.CheckBox59.Checked = False
                Setting.CheckBox6.Checked = True
            End If
        Else
            ReadXValue()
            Setting.CheckBox59.Checked = False
            Setting.CheckBox6.Checked = False
            Exit Sub
        End If

        Try
            Using reader As New StreamReader(MedGuiR.TextBox4.Text & "\" & addpath & p_c & ".cfg")
                While Not reader.EndOfStream
                    row = reader.ReadLine
                    SetValue()
                    SetGeneral()
                    'Exit While
                End While
                reader.Dispose()
                reader.Close()
            End Using
            update_setting()
        Catch e As Exception
            Console.WriteLine("The file could not be read:")
            Console.WriteLine(e.Message)
        End Try
    End Sub
    Public Sub SetValue()
        If consoles = "pce" Then
            If MedGuiR.CheckBox1.Checked = False Then p_c = "pce" : MedGuiR.tpce = "" Else p_c = "pce_fast" : MedGuiR.tpce = "_fast"
        ElseIf consoles = "snes" Then
            If MedGuiR.CheckBox15.Checked = False Then p_c = "snes" : MedGuiR.tpce = "" Else p_c = "snes_faust" : MedGuiR.tpce = "_faust"
        Else : p_c = consoles : MedGuiR.tpce = ""
        End If

        Select Case ext
            Case ".lnx"
                If row.Contains(consoles & ".lowpass ") Then xValue = Trim(Replace(row, consoles & ".lowpass", "")) : Setting.CheckBox18.Checked = CBool(xValue)
                If row.Contains(consoles & ".rotateinput ") Then xValue = Trim(Replace(row, consoles & ".rotateinput", "")) : Setting.CheckBox17.Checked = CBool(xValue)
                Setting.tab_index = 7
            Case ".gb", ".gbc"
                If row.Contains("snes.") Then
                    Exit Sub
                Else
                    If row.Contains(consoles & ".system_type ") Then xValue = Trim(Replace(row, consoles & ".system_type", "")) : Setting.ComboBox10.Text = xValue
                    Setting.tab_index = 8
                End If
            Case ".ngp", ".ngc", ".npc"
                If row.Contains(consoles & ".language ") Then xValue = Trim(Replace(row, consoles & ".language", "")) : Setting.ComboBox11.Text = xValue
                Setting.tab_index = 9
            Case ".nes", ".nsf", ".unf", ".nez", ".fds"
                If row.Contains("snes.") Then
                    Exit Sub
                Else

                    If row.Contains(consoles & ".clipsides ") Then xValue = Trim(Replace(row, consoles & ".clipsides", "")) : Setting.CheckBox19.Checked = CBool(xValue)
                    If row.Contains(consoles & ".correct_aspect ") Then xValue = Trim(Replace(row, consoles & ".correct_aspect", "")) : Setting.CheckBox20.Checked = CBool(xValue)
                    If row.Contains(consoles & ".gg ") Then xValue = Trim(Replace(row, consoles & ".gg", "")) : Setting.CheckBox21.Checked = CBool(xValue)
                    If row.Contains(consoles & ".input.fcexp ") Then xValue = Trim(Replace(row, consoles & ".input.fcexp", "")) : Setting.ComboBox12.Text = xValue
                    'For i = 1 To 4
                    If row.Contains(consoles & ".input.port" & 1 & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & 1, "")) : Setting.ComboBox13.Text = xValue
                    'Next
                    If row.Contains(consoles & ".n106bs ") Then xValue = Trim(Replace(row, consoles & ".n106bs", "")) : Setting.CheckBox22.Checked = CBool(xValue)
                    If row.Contains(consoles & ".no8lim ") Then xValue = Trim(Replace(row, consoles & ".no8lim", "")) : Setting.CheckBox23.Checked = CBool(xValue)
                    If row.Contains(consoles & ".ntsc.mergefields ") Then xValue = Trim(Replace(row, consoles & ".ntsc.mergefields", "")) : Setting.CheckBox27.Checked = CBool(xValue)
                    If row.Contains(consoles & ".nofs ") Then xValue = Trim(Replace(row, consoles & ".nofs", "")) : Setting.CheckBox24.Checked = CBool(xValue)
                    If row.Contains(consoles & ".ntsc.preset ") Then xValue = Trim(Replace(row, consoles & ".ntsc.preset", "")) : Setting.ComboBox14.Text = xValue
                    If row.Contains(consoles & ".ntscblitter ") Then xValue = Trim(Replace(row, consoles & ".ntscblitter", "")) : Setting.CheckBox25.Checked = CBool(xValue)
                    If row.Contains(consoles & ".pal ") Then xValue = Trim(Replace(row, consoles & ".pal", "")) : Setting.CheckBox26.Checked = CBool(xValue)
                    If row.Contains(consoles & ".soundq ") Then xValue = Trim(Replace(row, consoles & ".soundq", "")) : Setting.NumericUpDown8.Value = Val(xValue)

                    Setting.tab_index = 10
                End If
            Case ".pce", ".hes"
                pce()
            Case ".smd", ".gen", ".32x", ".md", ".bin"
                If row.Contains(consoles & ".correct_aspect ") Then xValue = Trim(Replace(row, consoles & ".correct_aspect", "")) : Setting.CheckBox34.Checked = CBool(xValue)
                If row.Contains(consoles & ".input.auto ") Then xValue = Trim(Replace(row, consoles & ".input.auto", "")) : Setting.CheckBox8.Checked = CBool(xValue)

                For i = 1 To 2
                    Select Case i
                        Case 1
                            If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox19.Text = xValue
                        Case 2
                            If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox20.Text = xValue
                    End Select
                Next

                If row.Contains(consoles & ".region ") Then xValue = Trim(Replace(row, consoles & ".region", "")) : Setting.ComboBox17.Text = xValue
                If row.Contains(consoles & ".reported_region ") Then xValue = Trim(Replace(row, consoles & ".reported_region", "")) : Setting.ComboBox18.Text = xValue
                If row.Contains(consoles & ".input.multitap ") Then xValue = Trim(Replace(row, consoles & ".input.multitap", "")) : Setting.ComboBox42.Text = xValue
                If row.Contains(consoles & ".input.mouse_sensitivity ") Then xValue = Trim(Replace(row, consoles & ".input.mouse_sensitivity", "")) : Setting.NumericUpDown16.Value = Val(xValue)
                Setting.tab_index = 12
            Case ".sms"
                If row.Contains(consoles & ".fm ") Then xValue = Trim(Replace(row, consoles & ".fm", "")) : Setting.CheckBox35.Checked = CBool(xValue)
                If row.Contains(consoles & ".territory ") Then xValue = Trim(Replace(row, consoles & ".territory", "")) : Setting.ComboBox21.Text = xValue
                If row.Contains(consoles & ".slend ") Then xValue = Trim(Replace(row, consoles & ".slend", "")) : Setting.TrackBar17.Value = Val(xValue)
                If row.Contains(consoles & ".slendp ") Then xValue = Trim(Replace(row, consoles & ".slendp", "")) : Setting.TrackBar18.Value = Val(xValue)
                If row.Contains(consoles & ".slstart ") Then xValue = Trim(Replace(row, consoles & ".slstart", "")) : Setting.TrackBar19.Value = Val(xValue)
                If row.Contains(consoles & ".slstartp ") Then xValue = Trim(Replace(row, consoles & ".slstartp", "")) : Setting.TrackBar20.Value = Val(xValue)
                Setting.tab_index = 13
            Case ".smc", ".fig", ".sfc", ".swc", ".ufo", ".gd3", ".gd7", ".dx2", ".mgd", ".mgh", ".bs", ".st", ".spc"
                If p_c = "snes" Then
                    If row.Contains(consoles & ".correct_aspect ") Then xValue = Trim(Replace(row, consoles & ".correct_aspect", "")) : Setting.CheckBox36.Checked = CBool(xValue)
                    If row.Contains(consoles & ".apu.resamp_quality ") Then xValue = Trim(Replace(row, consoles & ".apu.resamp_quality", "")) : Setting.NumericUpDown17.Value = Val(xValue)
                    If row.Contains(consoles & ".h_blend ") Then xValue = Trim(Replace(row, consoles & ".h_blend", "")) : Setting.CheckBox96.Checked = CBool(xValue)

                    For i = 1 To 2
                        Select Case i
                            Case 1
                                If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox22.Text = xValue
                                If row.Contains(consoles & ".input.port" & i & ".multitap") Then xValue = Trim(Replace(row, consoles & ".input.port" & i & ".multitap", "")) : Setting.CheckBox37.Checked = CBool(xValue)
                            Case 2
                                If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox23.Text = xValue
                                If row.Contains(consoles & ".input.port" & i & ".multitap") Then xValue = Trim(Replace(row, consoles & ".input.port" & i & ".multitap", "")) : Setting.CheckBox38.Checked = CBool(xValue)
                        End Select

                    Next
                    If row.Contains(consoles & ".mouse_sensitivity ") Then xValue = Trim(Replace(row, consoles & ".mouse_sensitivity", "")) : Setting.NumericUpDown10.Value = Val(xValue)
                    Setting.tab_index = 14
                ElseIf p_c = "snes_faust" Then
                    If row.Contains(consoles & MedGuiR.tpce & ".spex ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".spex", "")) : Setting.CheckBox63.Checked = CBool(xValue)
                    If row.Contains(consoles & MedGuiR.tpce & ".spex.sound ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".spex.sound", "")) : Setting.CheckBox64.Checked = CBool(xValue)
                    If row.Contains(consoles & MedGuiR.tpce & ".resamp_quality ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".resamp_quality", "")) : Setting.NumericUpDown18.Value = Val(xValue)
                    If row.Contains(consoles & MedGuiR.tpce & ".input.sport1.multitap ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".input.sport1.multitap", "")) : Setting.CheckBox99.Checked = CBool(xValue)
                    If row.Contains(consoles & MedGuiR.tpce & ".input.sport2.multitap ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".input.sport2.multitap", "")) : Setting.CheckBox98.Checked = CBool(xValue)
                    If row.Contains(consoles & MedGuiR.tpce & ".correct_aspect ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".correct_aspect", "")) : Setting.CheckBox102.Checked = CBool(xValue)

                    For i = 1 To 2
                        Select Case i
                            Case 1
                                If row.Contains(consoles & MedGuiR.tpce & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".input.port" & i, "")) : Setting.ComboBox46.Text = xValue
                            Case 2
                                If row.Contains(consoles & MedGuiR.tpce & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".input.port" & i, "")) : Setting.ComboBox47.Text = xValue
                        End Select

                    Next
                    Setting.tab_index = 20
                End If
            Case ".vb", ".vboy"
                If row.Contains(consoles & ".3dmode ") Then xValue = Trim(Replace(row, consoles & ".3dmode", "")) : Setting.ComboBox24.Text = xValue
                If row.Contains(consoles & ".3dreverse ") Then xValue = Trim(Replace(row, consoles & ".3dreverse", "")) : Setting.CheckBox39.Checked = CBool(xValue)
                If row.Contains(consoles & ".allow_draw_skip ") Then xValue = Trim(Replace(row, consoles & ".allow_draw_skip", "")) : Setting.CheckBox40.Checked = CBool(xValue)
                If row.Contains(consoles & ".anaglyph.lcolor ") Then xValue = Trim(Replace(row, consoles & ".anaglyph.lcolor", "")) : Setting.Label92.Text = (xValue) : Setting.Label92.BackColor = ColorTranslator.FromHtml(xValue) : Setting.Label92.ForeColor = ColorTranslator.FromHtml(xValue)
                If row.Contains(consoles & ".anaglyph.preset ") Then xValue = Trim(Replace(row, consoles & ".anaglyph.preset", "")) : Setting.ComboBox25.Text = xValue
                If row.Contains(consoles & ".anaglyph.rcolor ") Then xValue = Trim(Replace(row, consoles & ".anaglyph.rcolor", "")) : Setting.Label93.Text = (xValue) : Setting.Label93.BackColor = ColorTranslator.FromHtml(xValue) : Setting.Label93.ForeColor = ColorTranslator.FromHtml(xValue)
                If row.Contains(consoles & ".cpu_emulation ") Then xValue = Trim(Replace(row, consoles & ".cpu_emulation", "")) : Setting.ComboBox26.Text = xValue
                If row.Contains(consoles & ".default_color ") Then xValue = Trim(Replace(row, consoles & ".default_color", "")) : Setting.Label91.Text = (xValue) : Setting.Label91.BackColor = ColorTranslator.FromHtml(xValue) : Setting.Label91.ForeColor = ColorTranslator.FromHtml(xValue)
                If row.Contains(consoles & ".disable_parallax ") Then xValue = Trim(Replace(row, consoles & ".disable_parallax", "")) : Setting.CheckBox41.Checked = CBool(xValue)
                If row.Contains(consoles & ".input.instant_read_hack ") Then xValue = Trim(Replace(row, consoles & ".input.instant_read_hack", "")) : Setting.CheckBox42.Checked = CBool(xValue)
                If row.Contains(consoles & ".instant_display_hack ") Then xValue = Trim(Replace(row, consoles & ".instant_display_hack", "")) : Setting.CheckBox43.Checked = CBool(xValue)
                If row.Contains(consoles & ".liprescale ") Then xValue = Trim(Replace(row, consoles & ".liprescale", "")) : Setting.NumericUpDown11.Value = Val(xValue)
                If row.Contains(consoles & ".sidebyside.separation ") Then xValue = Trim(Replace(row, consoles & ".sidebyside.separation", "")) : Setting.TrackBar13.Value = Val(xValue)
                If row.Contains(consoles & ".ledonscale ") Then xValue = Trim(Replace(row, consoles & ".ledonscale", "")) : Setting.NumericUpDown26.Value = Val(xValue)
                Setting.tab_index = 15
            Case ".ws", ".wsr", ".wsc"
                If row.Contains(consoles & ".bday ") Then xValue = Trim(Replace(row, consoles & ".bday", "")) : Setting.ComboBox27.Text = xValue
                If row.Contains(consoles & ".blood ") Then xValue = Trim(Replace(row, consoles & ".blood", "")) : Setting.ComboBox30.Text = xValue
                If row.Contains(consoles & ".bmonth ") Then xValue = Trim(Replace(row, consoles & ".bmonth", "")) : Setting.ComboBox28.Text = xValue
                If row.Contains(consoles & ".byear ") Then xValue = Trim(Replace(row, consoles & ".byear", "")) : Setting.ComboBox29.Text = xValue
                If row.Contains(consoles & ".language ") Then xValue = Trim(Replace(row, consoles & ".language", "")) : Setting.ComboBox31.Text = xValue
                If row.Contains(consoles & ".name ") Then xValue = Trim(Replace(row, consoles & ".name", "")) : Setting.TextBox9.Text = xValue
                If row.Contains(consoles & ".rotateinput ") Then xValue = Trim(Replace(row, consoles & ".rotateinput", "")) : Setting.CheckBox44.Checked = CBool(xValue)
                If row.Contains(consoles & ".input.builtin ") Then xValue = Trim(Replace(row, consoles & ".input.builtin", "")) : Setting.ComboBox51.Text = xValue
                If row.Contains(consoles & ".sex ") Then xValue = Trim(Replace(row, consoles & ".sex", "")) : Setting.ComboBox32.Text = xValue
                Setting.tab_index = 16
            Case ".cue", ".m3u", ".toc", ".ccd"
                SetIso()
                'If row.Contains(consoles & ".correct_aspect ") Then xValue = Trim(Replace(row, consoles & ".correct_aspect", "")) : MsgBox(xValue)
        End Select

        If row.Contains(consoles & MedGuiR.tpce & ".forcemono ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".forcemono", "")) : Setting.CheckBox13.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & MedShader & " ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & MedShader, "")) : Setting.ComboBox7.Text = xValue

        If row.Contains(consoles & MedGuiR.tpce & ".shader.goat.pat ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".shader.goat.pat", "")) : Setting.ComboBox53.Text = xValue
        If row.Contains(consoles & MedGuiR.tpce & ".shader.goat.vdiv ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".shader.goat.vdiv", "")) : Setting.NumericUpDown24.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".shader.goat.hdiv ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".shader.goat.hdiv", "")) : Setting.NumericUpDown22.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".shader.goat.tp ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".shader.goat.tp", "")) : Setting.NumericUpDown23.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".shader.goat.fprog ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".shader.goat.fprog", "")) : Setting.CheckBox95.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".shader.goat.slen ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".shader.goat.slen", "")) : Setting.CheckBox94.Checked = CBool(xValue)

        If row.Contains(consoles & MedGuiR.tpce & ".scanlines ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".scanlines", "")) : Setting.TrackBar8.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".special ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".special", "")) : Setting.ComboBox8.Text = xValue
        If row.Contains(consoles & MedGuiR.tpce & ".stretch ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".stretch", "")) : Setting.ComboBox5.Text = xValue
        If row.Contains(consoles & MedGuiR.tpce & ".tblur ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".tblur", "")) : Setting.CheckBox14.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".tblur.accum ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".tblur.accum", "")) : Setting.CheckBox15.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".tblur.accum.amount ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".tblur.accum.amount", "")) : Setting.TrackBar9.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".videoip ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".videoip", "")) : Setting.ComboBox9.Text = xValue
        If row.Contains(consoles & MedGuiR.tpce & ".xres ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".xres", "")) : Setting.ComboBox6.Text = xValue
        If row.Contains(consoles & MedGuiR.tpce & ".xscale ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".xscale", "")) : Setting.NumericUpDown3.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".xscalefs ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".xscalefs", "")) : Setting.NumericUpDown5.Value = Val(xValue)

        If row.Contains(consoles & MedGuiR.tpce & ".yres ") Then
            xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".yres", ""))
            If Setting.ComboBox6.Items.Contains(Setting.ComboBox6.Text & "x" & xValue) = False Then
                Setting.ComboBox6.Items.Add(Setting.ComboBox6.Text & "x" & xValue)
            End If
            Setting.ComboBox6.Text = (Setting.ComboBox6.Text & "x" & xValue)
        End If

        If row.Contains(consoles & MedGuiR.tpce & ".yscale ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".yscale", "")) : Setting.NumericUpDown4.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".yscalefs ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".yscalefs", "")) : Setting.NumericUpDown6.Value = Val(xValue)

        'BIOS
        If row.Contains("gba.bios ") Then xValue = Trim(Replace(row, "gba.bios", "")) : Setting.TextBox10.Text = xValue
        If row.Contains("nes.ggrom ") Then xValue = Trim(Replace(row, "nes.ggrom", "")) : Setting.TextBox11.Text = xValue
        If row.Contains("pce" & MedGuiR.tpce & ".cdbios ") Then xValue = Trim(Replace(row, "pce" & MedGuiR.tpce & ".cdbios", "")) : Setting.TextBox12.Text = xValue
        If row.Contains("pcfx.bios ") Then xValue = Trim(Replace(row, "pcfx.bios", "")) : Setting.TextBox13.Text = xValue
        If row.Contains("md.cdbios ") Then xValue = Trim(Replace(row, "md.cdbios", "")) : Setting.TextBox14.Text = xValue
        If row.Contains("pce.gecdbios ") Then xValue = Trim(Replace(row, "pce.gecdbios", "")) : Setting.TextBox18.Text = xValue
        If row.Contains("psx.bios_eu ") Then xValue = Trim(Replace(row, "psx.bios_eu", "")) : Setting.TextBox15.Text = xValue
        If row.Contains("psx.bios_jp ") Then xValue = Trim(Replace(row, "psx.bios_jp", "")) : Setting.TextBox16.Text = xValue
        If row.Contains("psx.bios_na ") Then xValue = Trim(Replace(row, "psx.bios_na", "")) : Setting.TextBox17.Text = xValue
        If row.Contains("ss.bios_jp ") Then xValue = Trim(Replace(row, "psx.bios_jp", "")) : Setting.TextBox22.Text = xValue
        If row.Contains("ss.bios_na_eu ") Then xValue = Trim(Replace(row, "psx.bios_na", "")) : Setting.TextBox23.Text = xValue
    End Sub

    Public Sub SetGeneral()
        If row.Contains(";") Or row.Contains("ffnosound") Then Exit Sub

        If row.Contains("autosave ") Then xValue = Trim(Replace(row, "autosave", "")) : Setting.CheckBox9.Checked = CBool(xValue)
        If row.Contains("cd.image_memcache ") Then xValue = Trim(Replace(row, "cd.image_memcache", "")) : Setting.CheckBox10.Checked = CBool(xValue)
        If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : Setting.CheckBox11.Checked = CBool(xValue)
        If row.Contains("ffspeed ") Then xValue = Trim(Replace(row, "ffspeed", "")) : Setting.NumericUpDown1.Value = Val(xValue)
        If row.Contains("srwautoenable ") Then xValue = Trim(Replace(row, "srwautoenable", "")) : Setting.CheckBox60.Checked = CBool(xValue)
        If row.Contains("filesys.untrusted_fip_check ") Then xValue = Trim(Replace(row, "filesys.untrusted_fip_check", "")) : Setting.CheckBox72.Checked = CBool(xValue)
        'If row.Contains("filesys.disablesavegz ") Then xValue = Trim(Replace(row, "filesys.disablesavegz", "")) : Setting.CheckBox12.Checked = CBool(xValue)
        If row.Contains("input.autofirefreq ") Then xValue = Trim(Replace(row, "input.autofirefreq", "")) : Setting.TrackBar6.Value = Val(xValue)
        If row.Contains("input.joystick.axis_threshold ") Then xValue = Trim(Replace(row, "input.joystick.axis_threshold", "")) : Setting.TrackBar7.Value = Val(xValue)
        If row.Contains("sfspeed ") Then xValue = Trim(Replace(row, "sfspeed", "")) : Setting.NumericUpDown2.Value = Val(xValue)
        If row.Contains("filesys.path_firmware ") Then xValue = Trim(Replace(row, "filesys.path_firmware", "")) : firmwarepath = xValue

        If row.Contains("sound ") And row.Contains("snes_faust.spex.sound ") = False Then xValue = Trim(Replace(row, "sound", "")) : Setting.CheckBox1.Checked = CBool(xValue)
        If row.Contains("sound.buffer_time ") Then xValue = Trim(Replace(row, "sound.buffer_time", "")) : Setting.TrackBar1.Value = Val(xValue)
        If row.Contains("sound.driver ") Then xValue = Trim(Replace(row, "sound.driver", "")) : Setting.ComboBox2.Text = xValue
        If row.Contains("sound.period_time ") Then xValue = Trim(Replace(row, "sound.period_time", "")) : Setting.TrackBar3.Value = Val(xValue)
        If row.Contains("sound.rate ") Then xValue = Trim(Replace(row, "sound.rate", "")) : Setting.ComboBox1.Text = xValue
        If row.Contains("sound.volume ") Then xValue = Trim(Replace(row, "sound.volume", "")) : Setting.TrackBar2.Value = Val(xValue)

        If row.Contains("video.blit_timesync ") Then xValue = Trim(Replace(row, "video.blit_timesync", "")) : Setting.CheckBox2.Checked = CBool(xValue)
        If row.Contains("video.driver ") Then xValue = Trim(Replace(row, "video.driver", "")) : Setting.ComboBox3.Text = xValue
        If row.Contains("video.deinterlacer ") Then xValue = Trim(Replace(row, "video.deinterlacer", "")) : Setting.ComboBox41.Text = xValue
        If row.Contains("video.frameskip ") Then xValue = Trim(Replace(row, "video.frameskip", "")) : Setting.CheckBox3.Checked = CBool(xValue)
        If row.Contains("video.fs ") Then xValue = Trim(Replace(row, "video.fs", "")) : Setting.CheckBox4.Checked = CBool(xValue)
        If row.Contains("video.glvsync ") Then xValue = Trim(Replace(row, "video.glvsync", "")) : Setting.CheckBox5.Checked = CBool(xValue)
        If row.Contains("video.disable_composition ") Then xValue = Trim(Replace(row, "video.disable_composition", "")) : Setting.CheckBox7.Checked = CBool(xValue)

        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)

        If row.Contains("netplay.host ") Then xValue = Trim(Replace(row, "netplay.host", "")) : Setting.cmbServer.Text = xValue
        If row.Contains("netplay.localplayers ") Then xValue = Trim(Replace(row, "netplay.localplayers", "")) : Setting.NumericUpDown7.Value = Val(xValue)
        If row.Contains("netplay.nick ") Then xValue = Trim(Replace(row, "netplay.nick", "")) : Setting.TextBox5.Text = xValue
        If row.Contains("netplay.password ") Then xValue = Trim(Replace(row, "netplay.password", "")) : Setting.TextBox6.Text = xValue
        If row.Contains("netplay.gamekey ") Then xValue = Trim(Replace(row, "netplay.gamekey", "")) : Setting.TextBox3.Text = xValue
        If row.Contains("netplay.port ") Then xValue = Trim(Replace(row, "netplay.port", "")) : Setting.TextBox7.Text = xValue
        If row.Contains("netplay.smallfont ") Then xValue = Trim(Replace(row, "netplay.smallfont", "")) : Setting.CheckBox16.Checked = CBool(xValue)
        If row.Contains("netplay.console.font ") Then xValue = Trim(Replace(row, "netplay.console.font", "")) : Setting.ComboBox50.Text = xValue
        If row.Contains("netplay.console.scale ") Then xValue = Trim(Replace(row, "netplay.console.scale", "")) : Setting.NumericUpDown21.Value = Val(xValue)
        If row.Contains("netplay.console.lines ") Then xValue = Trim(Replace(row, "netplay.console.lines", "")) : Setting.NumericUpDown20.Value = Val(xValue)

        If row.Contains("qtrecord.vcodec ") Then xValue = Trim(Replace(row, "qtrecord.vcodec", "")) : Setting.ComboBox4.Text = xValue
        If row.Contains("qtrecord.h_double_threshold ") Then xValue = Trim(Replace(row, "qtrecord.h_double_threshold", "")) : Setting.TrackBar5.Value = Val(xValue)
        If row.Contains("qtrecord.w_double_threshold ") Then xValue = Trim(Replace(row, "qtrecord.w_double_threshold", "")) : Setting.TrackBar4.Value = Val(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)
        'If row.Contains("cheats ") Then xValue = Trim(Replace(row, "cheats", "")) : MsgBox(xValue)

    End Sub
    Public Sub pce()

        'If row.Contains(consoles & MedGuiR.tpce & ".adpcmlp ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".adpcmlp", "")) : Setting.CheckBox28.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".adpcmextraprec ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".adpcmextraprec", "")) : Setting.CheckBox28.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".adpcmvolume ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".adpcmvolume", "")) : Setting.TrackBar10.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".arcadecard ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".arcadecard", "")) : Setting.CheckBox29.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".cddavolume ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".cddavolume", "")) : Setting.TrackBar11.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".cdpsgvolume ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".cdpsgvolume", "")) : Setting.TrackBar12.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".resamp_quality ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".resamp_quality", "")) : Setting.NumericUpDown14.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".forcesgx ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".forcesgx", "")) : Setting.CheckBox30.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".h_overscan ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".h_overscan", "")) : Setting.CheckBox31.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".input.multitap ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".input.multitap", "")) : Setting.CheckBox33.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".adpcmlp ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".adpcmlp", "")) : Setting.CheckBox70.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".correct_aspect ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".correct_aspect", "")) : Setting.CheckBox71.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".ocmultiplier ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".ocmultiplier", "")) : Setting.NumericUpDown25.Value = Val(xValue)

        For i = 1 To 5
            Select Case i
                Case 1
                    If row.Contains(consoles & MedGuiR.tpce & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".input.port" & i, "")) : Setting.ComboBox16.Text = xValue
                Case 2
                    If row.Contains(consoles & MedGuiR.tpce & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".input.port" & i, "")) : Setting.ComboBox40.Text = xValue
            End Select
        Next

        If row.Contains(consoles & MedGuiR.tpce & ".mouse_sensitivity ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".mouse_sensitivity", "")) : Setting.NumericUpDown9.Value = Val(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".nospritelimit ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".nospritelimit", "")) : Setting.CheckBox32.Checked = CBool(xValue)
        If row.Contains(consoles & MedGuiR.tpce & ".psgrevision ") Then xValue = Trim(Replace(row, consoles & MedGuiR.tpce & ".psgrevision", "")) : Setting.ComboBox15.Text = xValue
        Setting.tab_index = 11
    End Sub

    Public Sub SetIso()
        Select Case consoles
            Case "pcfx"
                If row.Contains(consoles & ".adpcm.emulate_buggy_codec ") Then xValue = Trim(Replace(row, consoles & ".adpcm.emulate_buggy_codec", "")) : Setting.CheckBox45.Checked = CBool(xValue)
                If row.Contains(consoles & ".adpcm.suppress_channel_reset_clicks ") Then xValue = Trim(Replace(row, consoles & ".adpcm.suppress_channel_reset_clicks", "")) : Setting.CheckBox46.Checked = CBool(xValue)
                If row.Contains(consoles & ".cdspeed ") Then xValue = Trim(Replace(row, consoles & ".cdspeed", "")) : Setting.TrackBar14.Value = Val(xValue)
                If row.Contains(consoles & ".cpu_emulation ") Then xValue = Trim(Replace(row, consoles & ".cpu_emulation", "")) : Setting.ComboBox33.Text = xValue
                If row.Contains(consoles & ".high_dotclock_width ") Then xValue = Trim(Replace(row, consoles & ".high_dotclock_width", "")) : Setting.ComboBox34.Text = xValue
                If row.Contains(consoles & ".resamp_quality ") Then xValue = Trim(Replace(row, consoles & ".resamp_quality", "")) : Setting.NumericUpDown15.Value = Val(xValue)

                For i = 1 To 8
                    Select Case i
                        Case 1
                            If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox35.Text = xValue
                            If row.Contains(consoles & ".input.port" & i & ".multitap ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i & ".multitap", "")) : Setting.CheckBox50.Checked = CBool(xValue)
                        Case 2
                            If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox36.Text = xValue
                            If row.Contains(consoles & ".input.port" & i & ".multitap ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i & ".multitap", "")) : Setting.CheckBox49.Checked = CBool(xValue)
                    End Select
                Next

                If row.Contains(consoles & ".mouse_sensitivity ") Then xValue = Trim(Replace(row, consoles & ".mouse_sensitivity", "")) : Setting.NumericUpDown12.Value = Val(xValue)
                If row.Contains(consoles & ".nospritelimit ") Then xValue = Trim(Replace(row, consoles & ".nospritelimit", "")) : Setting.CheckBox47.Checked = CBool(xValue)
                If row.Contains(consoles & ".rainbow.chromaip ") Then xValue = Trim(Replace(row, consoles & ".rainbow.chromaip", "")) : Setting.CheckBox48.Checked = CBool(xValue)
                Setting.tab_index = 17
            Case "psx"

                If row.Contains(consoles & ".input.analog_mode_ct ") Then xValue = Trim(Replace(row, consoles & ".input.analog_mode_ct", "")) : Setting.CheckBox51.Checked = CBool(xValue)
                If row.Contains(consoles & ".input.mouse_sensitivity ") Then xValue = Trim(Replace(row, consoles & ".input.mouse_sensitivity", "")) : Setting.NumericUpDown13.Value = Val(xValue)

                For i = 1 To 8
                    Select Case i
                        Case 1
                            If row.Contains(consoles & ".input.pport" & i & ".multitap ") Then xValue = Trim(Replace(row, consoles & ".input.pport" & i & ".multitap", "")) : Setting.CheckBox54.Checked = CBool(xValue)
                            If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox37.Text = xValue
                            If row.Contains(consoles & ".input.port" & i & ".memcard ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i & ".memcard", "")) : Setting.CheckBox52.Checked = CBool(xValue)
                            If row.Contains(consoles & ".input.port" & i & ".gun_chairs ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i & ".gun_chairs", "")) : Setting.Label86.Text = (xValue) : Setting.Label86.Text = (xValue) : Setting.Label86.BackColor = ColorTranslator.FromHtml(xValue) : Setting.Label86.ForeColor = ColorTranslator.FromHtml(xValue)
                        Case 2
                            If row.Contains(consoles & ".input.pport" & i & ".multitap ") Then xValue = Trim(Replace(row, consoles & ".input.pport" & i & ".multitap", "")) : Setting.CheckBox56.Checked = CBool(xValue)
                            If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox38.Text = xValue
                            If row.Contains(consoles & ".input.port" & i & ".memcard ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i & ".memcard", "")) : Setting.CheckBox53.Checked = CBool(xValue)
                            If row.Contains(consoles & ".input.port" & i & ".gun_chairs ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i & ".gun_chairs", "")) : Setting.Label87.Text = (xValue) : Setting.Label87.Text = (xValue) : Setting.Label87.BackColor = ColorTranslator.FromHtml(xValue) : Setting.Label87.ForeColor = ColorTranslator.FromHtml(xValue)
                    End Select

                Next

                If row.Contains(consoles & ".input.analog_mode_ct.compare") Then
                    xValue = Trim(Replace(row, consoles & ".input.analog_mode_ct.compare", ""))

                    Dim n = Convert.ToString(Convert.ToInt32(xValue, 16), 2)
                    Dim str As [String] = StrReverse(n)
                    Dim binres As String
                    For Each c As Char In str
                        binres = c.ToString & binres

                        Select Case binres
                            Case 1
                                Setting.CheckBox78.Checked = True
                            Case 10
                                Setting.CheckBox80.Checked = True
                            Case 100
                                Setting.CheckBox81.Checked = True
                            Case 1000
                                Setting.CheckBox79.Checked = True
                            Case 10000
                                Setting.CheckBox90.Checked = True
                            Case 100000
                                Setting.CheckBox93.Checked = True
                            Case 1000000
                                Setting.CheckBox91.Checked = True
                            Case 10000000
                                Setting.CheckBox92.Checked = True
                            Case 100000000
                                Setting.CheckBox82.Checked = True
                            Case 1000000000
                                Setting.CheckBox83.Checked = True
                            Case 10000000000
                                Setting.CheckBox85.Checked = True
                            Case 100000000000
                                Setting.CheckBox84.Checked = True
                            Case 1000000000000
                                Setting.CheckBox86.Checked = True
                            Case 10000000000000
                                Setting.CheckBox89.Checked = True
                            Case 100000000000000
                                Setting.CheckBox88.Checked = True
                            Case 1000000000000000
                                Setting.CheckBox87.Checked = True
                        End Select
                        If binres.Contains("1") Then binres = Replace(binres, "1", "0")
                    Next
                End If

                If row.Contains(consoles & ".region_autodetect ") Then xValue = Trim(Replace(row, consoles & ".region_autodetect", "")) : Setting.CheckBox55.Checked = CBool(xValue)
                If row.Contains(consoles & ".h_overscan ") Then xValue = Trim(Replace(row, consoles & ".h_overscan", "")) : Setting.CheckBox57.Checked = CBool(xValue)
                If row.Contains(consoles & ".bios_sanity ") Then xValue = Trim(Replace(row, consoles & ".bios_sanity", "")) : Setting.CheckBox58.Checked = CBool(xValue)
                If row.Contains(consoles & ".region_default ") Then xValue = Trim(Replace(row, consoles & ".region_default", "")) : Setting.ComboBox39.Text = xValue
                If row.Contains(consoles & ".spu.resamp_quality ") Then xValue = Trim(Replace(row, consoles & ".spu.resamp_quality", "")) : Setting.TrackBar15.Value = Val(xValue)
                Setting.tab_index = 18
            Case "ss"
                For i = 1 To 12
                    Select Case i
                        Case 1
                            If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox45.Text = xValue
                        Case 2
                            If row.Contains(consoles & ".input.port" & i & " ") Then xValue = Trim(Replace(row, consoles & ".input.port" & i, "")) : Setting.ComboBox44.Text = xValue
                    End Select

                Next

                If row.Contains(consoles & ".region_autodetect ") Then xValue = Trim(Replace(row, consoles & ".region_autodetect", "")) : Setting.CheckBox62.Checked = CBool(xValue)
                If row.Contains(consoles & ".region_default ") Then xValue = Trim(Replace(row, consoles & ".region_default", "")) : Setting.ComboBox43.Text = xValue
                If row.Contains(consoles & ".scsp.resamp_quality ") Then xValue = Trim(Replace(row, consoles & ".scsp.resamp_quality", "")) : Setting.TrackBar16.Value = Val(xValue)
                If row.Contains(consoles & ".smpc.autortc.lang ") Then xValue = Trim(Replace(row, consoles & ".smpc.autortc.lang", "")) : Setting.ComboBox48.Text = xValue
                If row.Contains(consoles & ".cart ") Then xValue = Trim(Replace(row, consoles & ".cart", "")) : Setting.ComboBox49.Text = xValue
                If row.Contains(consoles & ".bios_sanity ") Then xValue = Trim(Replace(row, consoles & ".bios_sanity", "")) : Setting.CheckBox67.Checked = CBool(xValue)
                If row.Contains(consoles & ".cd_sanity ") Then xValue = Trim(Replace(row, consoles & ".cd_sanity", "")) : Setting.CheckBox68.Checked = CBool(xValue)
                If row.Contains(consoles & ".smpc.autortc ") Then xValue = Trim(Replace(row, consoles & ".smpc.autortc", "")) : Setting.CheckBox66.Checked = CBool(xValue)
                If row.Contains(consoles & ".cart.kof95_path ") Then xValue = Trim(Replace(row, consoles & ".cart.kof95_path", "")) : Setting.TextBox2.Text = xValue
                If row.Contains(consoles & ".cart.ultraman_path ") Then xValue = Trim(Replace(row, consoles & ".cart.ultraman_path", "")) : Setting.TextBox1.Text = xValue
                If row.Contains(consoles & ".midsync ") Then xValue = Trim(Replace(row, consoles & ".midsync", "")) : Setting.CheckBox65.Checked = CBool(xValue)
                If row.Contains(consoles & ".correct_aspect ") Then xValue = Trim(Replace(row, consoles & ".correct_aspect", "")) : Setting.CheckBox75.Checked = CBool(xValue)
                If row.Contains(consoles & ".h_blend ") Then xValue = Trim(Replace(row, consoles & ".h_blend", "")) : Setting.CheckBox76.Checked = CBool(xValue)
                If row.Contains(consoles & ".h_overscan ") Then xValue = Trim(Replace(row, consoles & ".h_overscan", "")) : Setting.CheckBox77.Checked = CBool(xValue)
                If row.Contains(consoles & ".input.mouse_sensitivity ") Then xValue = Trim(Replace(row, consoles & ".input.mouse_sensitivity", "")) : Setting.NumericUpDown19.Value = Val(xValue)
                If row.Contains(consoles & ".input.sport1.multitap ") Then xValue = Trim(Replace(row, consoles & ".input.sport1.multitap", "")) : Setting.CheckBox101.Checked = CBool(xValue)
                If row.Contains(consoles & ".input.sport2.multitap ") Then xValue = Trim(Replace(row, consoles & ".input.sport2.multitap", "")) : Setting.CheckBox100.Checked = CBool(xValue)
                Setting.tab_index = 19
            Case "pce"
                pce()
        End Select

    End Sub

    Public Sub update_setting()
        'Setting.Text = scan.real_name & " Setting"
        Setting.Label1.Text = "Sound Buffer: " & Setting.TrackBar1.Value
        Setting.Label3.Text = "Sound Volume: " & Setting.TrackBar2.Value
        Setting.Label5.Text = "Sound Period Time: " & Setting.TrackBar3.Value
        Setting.Label8.Text = "Width Double Threshold: " & Setting.TrackBar4.Value
        Setting.Label9.Text = "Heigth Double Threshold: " & Setting.TrackBar5.Value
        Setting.Label12.Text = "Auto-fire frequency: " & Setting.TrackBar6.Value
        Setting.Label13.Text = "Joystick Axis Threshold: " & Setting.TrackBar7.Value
        Setting.Label24.Text = "Scanlines: " & Setting.TrackBar8.Value
        Setting.Label26.Text = "Blur Accumulation: " & Setting.TrackBar9.Value
        Setting.Label39.Text = "ADPCM Volume: " & Setting.TrackBar10.Value
        Setting.Label40.Text = "CD-DA Volume: " & Setting.TrackBar11.Value
        Setting.Label41.Text = "PSG Volume: " & Setting.TrackBar12.Value
        Setting.Label57.Text = "N° Pixels L/R to Views: " & Setting.TrackBar13.Value
        Setting.Label76.Text = "Emulated CD-ROM speed: " & Setting.TrackBar14.Value
        Setting.Label90.Text = "SPU Output Resampler Quality: " & Setting.TrackBar15.Value
        Setting.Label104.Text = "SCSP Output Resampler Quality: " & Setting.TrackBar16.Value
        Setting.Label120.Text = "Last scanline in NTSC mode: " & Setting.TrackBar17.Value
        Setting.Label121.Text = "Last scanline in PAL mode: " & Setting.TrackBar18.Value
        Setting.Label122.Text = "First scanline in NTSC mode: " & Setting.TrackBar19.Value
        Setting.Label123.Text = "First scanline in PAL mode: " & Setting.TrackBar20.Value
    End Sub
End Module